<h1 id="ttc_client.sh">ttc_client.sh</h1>
<h2
id="an-unofficial-helper-script-for-the-eso-tamriel-trade-centre-addon-for-linux-systems">An
(unofficial) helper script for the ESO Tamriel Trade Centre addon (for
linux systems)</h2>
<p>Provides a bash shell script</p>
<pre><code>ttc_client.sh</code></pre>
<p>to emulate what the windows TTC client does that comes with the TTC
addon. It was written for ESO running on steam/proton on linux systems.
It may work with ESO running on other layers (eg by tweaking
–eso-live-d, see below), but I don’t know.</p>
<p>When started up, ttc_client.sh downloads the price table (as a zip
file) and unzips it in the appropriate place.</p>
<p>It then monitors TamrielTradeCentre.lua in the ESO SavedVariables
directory - if this changes, it uploads TamrielTradeCentre.lua via the
form on the TTC web page
(https://ZONE.tamrieltradecentre.com/pc/Trade/WebClient (where ZONE=‘eu’
or ‘us’)). It uses the python3 script submit_to_ttc.py to do the
upload.</p>
<h3 id="prerequisites">Prerequisites</h3>
<p>If running Arch Linux, make a symlink:</p>
<pre><code>    cd ~
    ln -s ~/.local/share/Steam .steam</code></pre>
<p>so that steam files can be accessed under ~/.steam/ when running
debian (files are under ~/.steam/ by default) and Arch Linux.</p>
<p>Packages</p>
<ul>
<li>python3</li>
<li>chromium</li>
<li>git</li>
<li>curl</li>
<li>unzip</li>
</ul>
<p>are needed.</p>
<p>Under <a href="https://archlinux.org/">Arch Linux</a>, these can be
installed with
<code>sudo pacman -S --needed python3 chromium git curl unzip</code></p>
<p>Arch Linux needs some additional packages, which the packages
installed below on depend on. For python-selenium:</p>
<pre><code>    sudo pacman -S --needed python-build python-installer python-setuptools python-pytest python-setuptools-rust python-wheel
    sudo pacman -S --needed python-urllib3 python-certifi python-trio python-trio-websocket python-websocket-client</code></pre>
<p>Other distributions may not need these.</p>
<p>Finally,</p>
<ul>
<li>fswatch</li>
<li>python-selenium</li>
<li>selenium-manager</li>
</ul>
<p>packages are needed. Under Arch Linux, these are <a
href="https://aur.archlinux.org/packages">Arch User Repository (AUR)
packages</a> (ie contributed by users). Refer to the <a
href="https://wiki.archlinux.org/title/Arch_User_Repository">Arch User
Repository wiki</a> for help on installing if needed. [Note: the current
python-selenium version 4.24.0-1 seems broken. Use the previous version
4.22.0-1. In the python-selenium build directory run
<code>git checkout 65c77361b1b6621b4c4db06f1f97bc7bdd4c1f67</code> to
check out this version before running <code>makepkg</code> etc.]</p>
<p>Some non-Arch Linux distributions may package the selenium python
bindings (“python-selenium”) together with the selenium-manager
executable. A final alternative is to use the pip3 python installer to
install selenium (pip3 installs both the bindings and the
executable).</p>
<p>Arch Linux’s chromium package includes <code>chromedriver</code>
(needed to automate chromium). Other distributions may need a separate
package installing. Or download the linux64 chromedriver directly using
<a
href="https://googlechromelabs.github.io/chrome-for-testing/">https://googlechromelabs.github.io/chrome-for-testing/</a>
and move the chromedriver binary to somewhere in your PATH.</p>
<h3 id="download">Download</h3>
<p>(First-time download) Run</p>
<pre><code>git clone https://gitlab.com/bike9876-eso/eso/ttc_client_linux</code></pre>
<p>This will download files including bash script ttc_client.sh and
python3 script submit_to_ttc.py into directory ttc_client_linux relative
to the current directory.</p>
<p>(Subsequent updates) Run</p>
<pre><code>cd /path/to/ttc_client
git pull </code></pre>
<h3 id="usage">Usage</h3>
<p>If you use the EU ESO server, run</p>
<pre><code>/path/to/ttc_client/ttc_client.sh</code></pre>
<p>(replace <code>/path/to/ttc_client</code> with the actual path to
ttc_client.sh.) Suggest you start this before starting up ESO.</p>
<p>You can give the option <code>--zone eu</code>, but the EU zone is
the default, so there’s no need. Use <code>--zone us</code> if you use
the US ESO server.</p>
<p>This downloads the TTC price table, and monitors
TamrielTradeCentre.lua as described above. Press Ctrl-c after finished
playing to stop ttc_client.sh</p>
<p>After each upload of TamrielTradeCentre.lua, a list of the form:</p>
<pre><code>5:31:55 PM: Item Sealed Jewelry Crafter Writ has been posted.
5:31:55 PM: Item Sealed Jewelry Crafter Writ has been posted.
5:31:55 PM: Item Sealed Jewelry Crafter Writ has been posted.
5:31:55 PM: Item Rawhide has been posted.
...</code></pre>
<p>is output.</p>
<p>(An instance of chrome/chromium will also be fired temporarily up
showing the same information.)</p>
<h3 id="license">License</h3>
<p>This software is released under the MIT License. Please see
LICENSE.</p>
<h3 id="notes">Notes</h3>
<ul>
<li><p>If you’ve recently run ttc_client.sh, there’s no need to
re-download the price table (it only changes once a day, I think). Run
with option <code>--skip-download</code> to skip downloading
this.</p></li>
<li><p>On the other hand, if you only want to download the price table
(and not monitor TamrielTradeCentre.lua), use option
<code>--skip-monitor</code>.</p></li>
<li><p>The script assumes directory <code>eso_live_d</code> exists
(default
<code>~/.steam/steam/steamapps/compatdata/306130/pfx/drive_c/users/steamuser/My Documents/Elder Scrolls Online/live</code>).
If this directory is found elsewhere, use the –eso-live-d argument,
eg</p>
<pre><code>ttc_client.sh --eso-live-d ~/drive_c/users/steamuser/My\ Documents/Elder\ Scrolls\ Online/live</code></pre>
<p>(Be careful if there are spaces in the path - escape them with a
backslash.)</p></li>
<li><p>The script catches the text “Upload Completed” in the output of
the submission to
https://ZONE.tamrieltradecentre.com/pc/Trade/WebClient. If you have a
non English locale, your output might be different. Then use
–upload-completed-text, eg –upload-completed-text “Téléchargement
Terminé”. However, I think the output of the webclient is currently
always English, so this should not be an issue.</p></li>
<li><p>This is an unofficial script and is not endorsed in any way by
the authors of ESO or TTC.</p></li>
</ul>
<p><a href="https://エボ猫.コム/">bike9876@エボ猫.コム</a></p>
